
component {
	property name="gdprService" inject="gdprService";
	property name="formsService" inject="formsService";

	public function index(event, rc, prc, args={} ) {
				event.include( assetId="gdpr-settings-css" )
		
		args.gdprGroups = gdprService.getGroupsWithItems();

		args.newFormName = formsService.createForm( formName="gdprSettingsForm", generator=function( formDefinition ){
			var vCount=1;
						
			for(var group in args.gdprGroups) {
				
				formDefinition.addField(
					tab           = "default"
					, fieldset    = "default"
					, name        = "group_#group.id#"
					, label       = group.label
					, description = group.description
					, group       = group.id
					, layout      = "formcontrols.layouts.gdprfieldgroup"
					, control     = "gdprYesNoSwitch"
					, class       = "gdprGroup"
					, required    = false
					, count       = vCount
				);
				
				for(var item in group.items) {
				
					formDefinition.addField(
						tab        = "default"
						, fieldset = "default"
						, name     = "item_#item.id#"
					  , label       = item.label
					  , description = item.description
					  , group       = item.grouplist
						, control  = "gdprYesNoSwitch"
					  , class    = "gdprItem"
				    , layout   = "formcontrols.layouts.gdprfielditem"
						, required = false
					);
				}
				
				formDefinition.addField(
					tab           = "default"
					, fieldset    = "default"
					, name        = "groupend_#group.id#"
					, layout      = "formcontrols.layouts.gdprfieldgroup_end"
				);
				
				vCount++;
			}
		} );

		return renderView(
				view          = "/page-types/gdpr/index"
			, presideObject = "page"
			, id            = event.getCurrentPageId()
			, args          = args
		);

	}

}