
component {
	property name="GroupDao" inject="presidecms:object:gdprgroup";
	property name="ItemDao" inject="presidecms:object:gdpritem";
	property name="visitorService" inject="WebsiteVisitorService";


	public query function getGroups(any shortcode="" ) {
		var filter = {};
		if(!isEmpty(arguments.shortcode)) {
			filter = { shortcode = arguments.shortcode }
		}
		
		var result = GroupDao.selectdata(filter = filter, orderBy = "label asc");
		return result;
	}

	public query function getItems(any shortcode="" ) {
		var filter = {};
		if(!isEmpty(arguments.shortcode)) {
			filter = { shortcode = arguments.shortcode }
		}

		var result = ItemDao.selectdata(filter = filter, orderBy = "label asc");
		return result;
	}

	public query function getItemsForGroup(required string id="" ) {
		// TODO: The following query needs some performance optimization. Like is not the best choice here.
		var result = ItemDao.selectdata(
				selectFields = ["id","label","shortcode","description","privacyLink","group_concat( distinct groups.id ) as grouplist"]
				, groupBy = "id"
				, having       = "grouplist like :groups"
				, filterParams = { "groups" = "%#arguments.id#%" }	
		);
		
		return result;
	}

	public function getGroupsWithItems(any shortcode="" ) {
		var groups = getGroups(arguments.shortcode);
		var result = [];
		var temp = {};
		
		for(g in groups) {
			temp = g;
			temp.items = getItemsForGroup(g.id);
			arrayAppend(result,temp);
		}
		
		return result;
	}

	public function setItemPermissions() {
		
	}

}